poj1077 Eight【爆搜+Hash(脸题-_-b)】

题目链接:http://poj.org/problem?id=1077

题目描述:民间流传的推15游戏,不过这里简化为3*3,也就是八数码问题,‘x’表示空位。与AOJ0121的“Seven Puzzle”类似。

思路:没什么特别的,构造字符串队列,爆搜一下。注意Hash函数,哈得好就哈哈,哈得不好就只能呵呵了。。。我的hash函数是∑((str[i]*7^i))%1000007外加在x的位置加上i*10007,547MS水过。不过在一样的题hdu1043时限变成了5秒却还是TLE了,果然此题杭电的数据更强,看来是要用A*了。

#include <iostream>
#include <ios>
#include <iomanip>
#include <functional>
#include <algorithm>
#include <vector>
#include <sstream>
#include <list>
#include <queue>
#include <deque>
#include <stack>
#include <string>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cctype>
#include <cmath>
#include <cstring>
#include <climits>
using namespace std;
#define XINF INT_MAX
#define INF 1<<30
#define MAXN 1000007
#define eps 1e-10
#define zero(a) fabs(a)<eps
#define sqr(a) ((a)*(a))
#define MP(X,Y) make_pair(X,Y)
#define PB(X) push_back(X)
#define PF(X) push_front(X)
#define REP(X,N) for(int X=0;X<N;X++)
#define REP2(X,L,R) for(int X=L;X<=R;X++)
#define DEP(X,R,L) for(int X=R;X>=L;X--)
#define CLR(A,X) memset(A,X,sizeof(A))
#define IT iterator
#define PI  acos(-1.0)
#define test puts("OK");
#define _ ios_base::sync_with_stdio(0);cin.tie(0);
typedef long long ll;
typedef pair<int,int> PII;
typedef priority_queue<int,vector<int>,greater<int> > PQI;
typedef vector<PII> VII;
typedef vector<int> VI;
#define X first
#define Y second

inline int Hash(string str)
{
    int len=str.length(),s=7,ans=0;
    REP(i,len)
    {
        if(str[i]>=‘0‘ && str[i]<=‘9‘)
            ans+=(str[i]-‘0‘)*s;
        else
            ans+=i*10007;
        s*=7;
        ans=ans%MAXN;
    }
    return ans;
}

pair<int,int> par[MAXN];
bool vis[MAXN];
int dir[4][2]={{-1,0},{1,0},{0,1},{0,-1}};
char direction[4]={‘u‘,‘d‘,‘r‘,‘l‘};
char ans[100000+10];

void bfs(string start,string end)
{
    CLR(vis,0);
    queue<string> Q;
    int s=Hash(start);
    Q.push(start);
    vis[s]=1;
    par[s]=MP(s,-1);
    while(!Q.empty())
    {
        string temp=Q.front();Q.pop();
        if(temp==end)
            break;
        int pos;
        REP(i,9)
            if(temp[i]==‘x‘)
                pos=i;
        int x=pos/3,y=pos%3;
        REP(i,4)
        {
            int tx=x+dir[i][0],ty=y+dir[i][1];
            if(tx>=0 && tx<3 && ty>=0 && ty<3)
            {
                string next=temp;
                swap(next[tx*3+ty],next[x*3+y]);
                int ll=Hash(next);
                if(!vis[ll])
                {
                    par[ll]=MP(Hash(temp),i);
                    vis[ll]=1;
                    Q.push(next);
                }
            }
        }
    }
}

int main()
{_
    string s="";
    REP(i,9)
    {
        char c;
        cin>>c;
        s+=c;
    }
    bfs(s,"12345678x");
    int res=Hash("12345678x"),tot=0;
    while(par[res].X!=res)
    {
        ans[tot++]=direction[par[res].Y];
        res=par[res].X;
    }
    for(int i=tot-1;i>=0;i--)
        cout<<ans[i];
    cout<<endl;
    return 0;
}
时间: 2024-11-07 00:53:17

poj1077 Eight【爆搜+Hash(脸题-_-b)】的相关文章

HDU 3316 爆搜水题

爆搜水题 模拟扫雷,规则和扫雷一样 给出原图,求在X,Y位置点一下以后的图形,没有弹出的点输出-1,弹出的点输出这个点的数字 从起始点DFS一下即可 #include "stdio.h" #include "string.h" int dir[8][2]={ {-1,0},{-1,1},{0,1},{1,1},{1,0},{1,-1},{0,-1},{-1,-1} }; int n; int hash[110][110]; char str[110][110]; i

有一种恐怖,叫大爆搜

到目前这个阶段,大爆搜做了好几个,有必要做一下小的总结了. 玛雅游戏:出门左转 http://www.cnblogs.com/Loser-of-Life/p/7247413.html的A 斗地主:出门右转http://www.cnblogs.com/Loser-of-Life/p/7259858.html的B 天鹅会面:出门直行http://www.cnblogs.com/Loser-of-Life/p/7295770.html的A 引水入城:链接:http://cogs.pro/cogs/pr

POJ 1166 The Clocks (爆搜 || 高斯消元)

题目链接 题意: 输入提供9个钟表的位置(钟表的位置只能是0点.3点.6点.9点,分别用0.1.2.3)表示.而题目又提供了9的步骤表示可以用来调正钟的位置,例如1 ABDE表示此步可以在第一.二.四.五个钟调正,如原来是0点,那么调正后为3点.问经过那些步骤可以导致9个钟的位置都在0点. 分析: 这个本来是一个高斯消元的题目,但是 听说周期4不是素数, 求解过程中不能进行取余.因为取余可能导致解集变大. 不过也有用高斯消元做的,下面是用高斯消元的分析 ” Discuss也有人讨论了,4不是质数

【BZOJ-1853&amp;2393】幸运数字&amp;Cirno的完美算数教室 容斥原理 + 爆搜 + 剪枝

1853: [Scoi2010]幸运数字 Time Limit: 2 Sec  Memory Limit: 64 MBSubmit: 1817  Solved: 665[Submit][Status][Discuss] Description 在中国,很多人都把6和8视为是幸运数字!lxhgww也这样认为,于是他定义自己的“幸运号码”是十进制表示中只包含数字6和8的那些号码,比如68,666,888都是“幸运号码”!但是这种“幸运号码”总是太少了,比如在[1,100]的区间内就只有6个(6,8,

8/2 multi4 E找规律+模拟,空间开小了然后一直WA。。。J爆搜check不严谨WA。。。multi3 G凸包判共线写错数组名???样例太好过.想哭jpg。

multi4 Problem E. Matrix from Arrays 题意:构造一个数组,求子矩阵前缀和. 思路:打表找规律,"发现"L为奇数时循环节为L,为偶数时循环节为2L,求相应循环节的二维前缀和然后加加减减计算一下就好. 虚伪地证明一下循环节:L为奇数时对于第x行/列开始的位置有(x  +  x+L-1)*L/2   ->     (2x+L-1)/2(为整数)*L,因此扫过L行/列也就扫过了L整数倍"(2x+L-1)/2"倍的A[0]~A[L],

Bandwidth(爆搜)

这是一道暴力都能过的题,重点其实在于理解题意,输入过程也有一点繁琐. 1.题意 先给定一个无向图,要重新安排结点的顺序,使得相邻的节点在排列中的最大距离最小 2.Solution 明显的爆搜,难就难在如何建模,其实只要把出现过的字符放到一个数组记录起来,然后搜索的时候依次安排每个节点的字母 分块讲解: (1)输入 //首先我们可以先把":"前面的字符提出来作为u,再在:后面的字符拿出来做v //Coder-cjh void init(){ mind=1e9;tot=0; memset(

关于爆搜

关于爆搜 ? (这还用说,讲者太菜了) ? 爆搜通常是没有思路时一个 优秀 玄学的解题方法,但同样是搜索,我们所的分数却相差甚远,即搜索的优化问题; 前言 ? 这是很基础的东西,这里只作为回顾. ? 讲着实力不足,请不要D讲者; BFS ? BFS,广度优先搜索,用于逐层拓展的工具,可以有效地通过比较同一层之间的结果进行有效地减枝,而相比之下DFS的减枝就比较玄学,故能用BFS时,BFS的时间复杂度一般比DFS要低很多; ? BFS也是SPFA的实现基础 虽然SPFA已经死了 . ? BFS有双

结对编程_附加题_博客2

1.界面模块,测试模块和核心模块的松耦合 2.改进程序 结对编程_附加题_博客2

爆搜解hdu1572下沙小面的(2)

#include<iostream> #include<map> #include<string> #include<cstring> #include<cstdio> #include<cstdlib> #include<cmath> #include<queue> #include<vector> #include<algorithm> using namespace std; in